'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = render;

var _batchInsertMessages = require('./batchInsertMessages');

var _NodeProxy = require('./NodeProxy');

var _is = require('./is');

var _symbol = require('./symbol');

var _get = require('./get');

var _set = require('./set');

/* @flow */

/*:: import type {VirtualElement} from './types'*/
function render(vnode /*: VirtualElement*/, node /*: HTMLElement*/) /*: void*/ {
  var containerProxy /*: NodeProxy*/ = _NodeProxy.NodeProxy.fromElement(node);
  var previous /*: VirtualElement*/ = (0, _get.get)(node, _symbol.$$root);

  if ((0, _is.isDefined)(previous)) {
    if (previous.tagName === vnode.tagName) {
      previous.patch(vnode);
    } else {
      previous.destroy();
    }
  }

  (0, _batchInsertMessages.batchInsertMessages)(function (queue) {
    vnode.initialize();
    containerProxy.replaceChild(vnode.getProxy(), 0);
    queue.push(vnode);
  });

  (0, _set.set)(node, _symbol.$$root, vnode);
}